Skip to main content

## ConstantKind

# Enum ConstantKind

Source

    pub(crate) enum ConstantKind {
        TyConst {
            expr: Box<str>,
        },
        Path {
            path: Box<str>,
        },
        Anonymous {
            body: BodyId,
        },
        Extern {
            def_id: DefId,
        },
        Local {
            def_id: DefId,
            body: BodyId,
        },
        Infer,
    }

## Variants§

§

### TyConst

This is the wrapper around `ty::Const` for a non-local constant. Because it doesn’t have a `BodyId`, we need to handle it on its own.

Note that `ty::Const` includes generic parameters, and may not always be uniquely identified by a DefId. So this field must be different from `Extern`.

#### Fields

§`expr: Box<str>`
§

### Path

A constant that is just a path (i.e., referring to a const param, free const, etc.).

#### Fields

§`path: Box<str>`
§

### Anonymous

A constant (expression) that’s not an item or associated item. These are usually found nested inside types (e.g., array lengths) or expressions (e.g., repeat counts), and also used to define explicit discriminant values for enum variants.

#### Fields

§`body: BodyId`
§

### Extern

A constant from a different crate.

#### Fields

§`def_id: DefId`
§

### Local

`const FOO: u32 = ...;`

#### Fields

§`def_id: DefId`
§`body: BodyId`
§

### Infer

An inferred constant as in `[10u8; _]`.

## Implementations§

Source§

### impl ConstantKind

Source

#### pub(crate) fn expr(&self, tcx: TyCtxt<'_>) -> String

Source

#### pub(crate) fn value(&self, tcx: TyCtxt<'_>) -> Option<String>

Source

#### pub(crate) fn is_literal(&self, tcx: TyCtxt<'_>) -> bool

## Trait Implementations§

Source§

### impl Clone for ConstantKind

Source§

#### fn clone(&self) -> ConstantKind

Returns a duplicate of the value. Read more
1.0.0 (const: unstable) · Source§

#### fn clone_from(&mut self, source: &Self)

Performs copy-assignment from `source`. Read more
Source§

### impl Debug for ConstantKind

Source§

#### fn fmt(&self, f: &mut Formatter<'_>) -> Result

Formats the value using the given formatter. Read more
Source§

### impl Eq for ConstantKind

Source§

### impl FromClean<ConstantKind> for Constant

Source§

#### fn from_clean(constant: &ConstantKind, renderer: &JsonRenderer<'_>) -> Self

Source§

### impl Hash for ConstantKind

Source§

#### fn hash<__H: Hasher>(&self, state: &mut __H)

Feeds this value into the given `Hasher`. Read more
1.3.0 · Source§

#### fn hash_slice<H>(data: &[Self], state: &mut H)
where H: Hasher, Self: Sized,

Feeds a slice of this type into the given `Hasher`. Read more
Source§

### impl PartialEq for ConstantKind

Source§

#### fn eq(&self, other: &ConstantKind) -> bool

Equality operator `==`. Read more
1.0.0 (const: unstable) · Source§

#### fn ne(&self, other: &Rhs) -> bool

Inequality operator `!=`. Read more
Source§

### impl StructuralPartialEq for ConstantKind

## Auto Trait Implementations§

§

### impl Freeze for ConstantKind

§

### impl RefUnwindSafe for ConstantKind

§

### impl Send for ConstantKind

§

### impl Sync for ConstantKind

§

### impl Unpin for ConstantKind

§

### impl UnsafeUnpin for ConstantKind

§

### impl UnwindSafe for ConstantKind

## Blanket Implementations§

Source§

### impl<T> Any for T
where T: 'static + ?Sized,

Source§

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more
Source§

### impl<T> Borrow<T> for T
where T: ?Sized,

Source§

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
Source§

### impl<T> BorrowMut<T> for T
where T: ?Sized,

Source§

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
Source§

### impl<T> CloneToUninit for T
where T: Clone,

Source§

#### unsafe fn clone_to_uninit(&self, dest: *mut u8)

🔬This is a nightly-only experimental API. (`clone_to_uninit`)
Performs copy-assignment from `self` to `dest`. Read more
§

### impl<Q, K> Equivalent<K> for Q
where Q: Eq + ?Sized, K: Borrow<Q> + ?Sized,

§

#### fn equivalent(&self, key: &K) -> bool

Checks if this value is equivalent to the given key. Read more
§

### impl<Q, K> Equivalent<K> for Q
where Q: Eq + ?Sized, K: Borrow<Q> + ?Sized,

§

#### fn equivalent(&self, key: &K) -> bool

Compare self to `key` and return `true` if they are equal.
Source§

### impl<T> From<T> for T

Source§

#### fn from(t: T) -> T

Returns the argument unchanged.

§

### impl<T> Instrument for T

§

#### fn instrument(self, span: Span) -> Instrumented<Self>

Instruments this type with the provided [`Span`], returning an `Instrumented` wrapper. Read more
§

#### fn in_current_span(self) -> Instrumented<Self>

Instruments this type with the current `Span`, returning an `Instrumented` wrapper. Read more
Source§

### impl<T, U> Into<U> for T
where U: From<T>,

Source§

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

Source§

### impl<T> IntoEither for T

Source§

#### fn into_either(self, into_left: bool) -> Either<Self, Self>

Converts `self` into a `Left` variant of `Either<Self, Self>` if `into_left` is `true`. Converts `self` into a `Right` variant of `Either<Self, Self>` otherwise. Read more
Source§

#### fn into_either_with<F>(self, into_left: F) -> Either<Self, Self>
where F: FnOnce(&Self) -> bool,

Converts `self` into a `Left` variant of `Either<Self, Self>` if `into_left(&self)` returns `true`. Converts `self` into a `Right` variant of `Either<Self, Self>` otherwise. Read more
Source§

### impl<T> ToOwned for T
where T: Clone,

Source§

#### type Owned = T

The resulting type after obtaining ownership.
Source§

#### fn to_owned(&self) -> T

Creates owned data from borrowed data, usually by cloning. Read more
Source§

#### fn clone_into(&self, target: &mut T)

Uses borrowed data to replace owned data, usually by cloning. Read more
Source§

### impl<T, U> TryFrom<U> for T
where U: Into<T>,

Source§

#### type Error = Infallible

The type returned in the event of a conversion error.
Source§

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.
Source§

### impl<T, U> TryInto<U> for T
where U: TryFrom<T>,

Source§

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
Source§

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.
§

### impl<T> WithSubscriber for T

§

#### fn with_subscriber<S>(self, subscriber: S) -> WithDispatch<Self>
where S: Into<Dispatch>,

Attaches the provided `Subscriber` to this type, returning a [`WithDispatch`] wrapper. Read more
§

#### fn with_current_subscriber(self) -> WithDispatch<Self>

Attaches the current default `Subscriber` to this type, returning a [`WithDispatch`] wrapper. Read more

## Layout§

Note: Most layout information is completely unstable and may even differ between compilations. The only exception is types with certain `repr(...)` attributes. Please see the Rust Reference's “Type Layout” chapter for details on type layout guarantees.

Size: 24 bytes

Size for each variant:

- `TyConst`: 20 bytes
- `Path`: 20 bytes
- `Anonymous`: 8 bytes
- `Extern`: 8 bytes
- `Local`: 16 bytes
- `Infer`: 0 bytes